#ifndef _VECTOR_HPP
#define _VECTOR_HPP

struct Vector {
    Vector();
    Vector(double _x, double _y);
    Vector(const Vector& o);
    static Vector rand();

    double dot(const Vector& o) const;
    Vector projectOnto(const Vector& o) const;
    Vector leftOrtho() const;
    Vector operator* (double fac) const;
    Vector operator+ (const Vector& o) const;
    void operator+= (const Vector& o);
    void operator-= (const Vector& o);
    void operator*= (double o);
    void operator*= (const Vector& o);
    Vector operator- () const;
    Vector operator- (Vector o) const;
    void operator= (const Vector& o);
    double len2() const;
    double len() const;
    Vector operator/ (double quo) const;
    Vector normalize() const;
    double angle() const;

    // Members
    double x = 0;
    double y = 0;
};

struct Area {
    Area(const Vector& _p1, const Vector& _p2);
    Vector p1, p2;
    double area() const;
    Area intersect(const Area& o) const;
};

#endif