#ifndef _CONFIG_HPP
#define _CONFIG_HPP

#define TAG_COUNT 0
#define TAG_POSITIONS 1
#define TAG_VELOCITIES 2

// bin/fluidsim --force 20 --power 1 --distance 0.001 --threshold 0.06 --damping 0.5 --speed 10 --rate 100                

struct Config {
    // simulation constants
    double D =  0.001; // distance
    double T =  0.060; // threshold
    double P =  1.000; // power
    double F = 20.000; // factor

    double SurfaceDamping   =   0.500;
    double StartSpeed       =  10.000;
    double EmissionRate     = 100.000;
    double TimeStep         =   0.001;

    // spawning
    unsigned int domainBufferSize = 10000;

    // grid
    int    gridColumns = 2;
    int    gridRows = 2;

    // runtime information
    int    rank = 0;
    int    clients = 1;
    bool   master = false;
    int    iteration = 0;
    char*  outdir = "../data";

    // Debugging
    bool debug = false;
    bool measure = false;
    int totalCount = 0;
};

extern Config config;

#endif