#ifndef _MESH_HPP
#define _MESH_HPP

#include "Vector.hpp"
#include "QuickSet.hpp"
#include <vector>
#include "MeshFragment.hpp"

class Mesh {
public:
    Mesh(int count, double radius);

    unsigned int id;
    Vector force;
    QuickSet<MeshFragment> fragments;
    double radius2;

    void addPoint(const Vector& point);
    void finish(bool close = true);

    bool isOutside(const Vector& p);
    std::vector<Vector> points;
};

#endif

