#include "MeshFragment.hpp"

#include "Utils.hpp"

bool MeshFragment::reflect(const Vector& before, Vector& after) {
    Vector p1 = before - pos; 
    Vector p2 = after - pos; 

    // dot product of normal
    double dp1 = nor.dot(p1);
    double dp2 = nor.dot(p2);
    int s1 = sgn(dp1);
    int s2 = sgn(dp2);

    // reflect if sign different or goal point on line
    if(nearZero(s2) || s1 != s2) {
        // find collision point (project p1 onto somewhere and stuff)
        Vector coll = after; // TODO
        // project diff onto normal
        Vector rest; // TODO
        // project rest onto normal and direction
        Vector restD = rest.projectOnto(dir);
        Vector restN = rest.projectOnto(nor);

        // modify after position
        after.x = coll.x + restD.x - restN.x;
        after.y = coll.y + restD.y - restN.y;
        return true;
    }

    return false;
}
