#ifndef _SIMULATION_HPP
#define _SIMULATION_HPP

#include <vector>

#include "Config.hpp"
#include "Grid.hpp"
#include "Mesh.hpp"
#include "QuickSet.hpp"
#include "Spawner.hpp"
#include "Vector.hpp"

struct Domain;
struct Particle;

struct Simulation {
    Simulation();
    void init();
    void tick(double dt);
    void sync();
    void write();
    void syncAll(int from = -1);
    void syncWith(int dx, int dy, bool sending);
    void receiveFrom(int rank);
    void insert(const Vector& pos, const Vector& vel = Vector());

    Grid grid;
    Domain** domains;

    QuickSet<Vector> receive_pos, receive_vel;
    std::vector<Mesh> meshes;
    std::vector<Spawner> spawners;
};

extern Simulation* sim;

#endif