#include "Spawner.hpp"
#include "Simulation.hpp"

#include "Utils.hpp"
#include <algorithm>

Spawner::Spawner(const Area& _area, double _rate, const Area& _velo) 
    : area(_area)
    , rate(_rate)
    , velo(_velo) {

}
void Spawner::tick(double dt) {
    accumulator += dt * rate;

    for(int i = 0; i < accumulator; ++i) {
        Vector pos(rand(area.p1.x, area.p2.x), rand(area.p1.y, area.p2.y));
        Vector vel(rand(velo.p1.x, velo.p2.x), rand(velo.p1.y, velo.p2.y));

        for(auto& mesh : sim->meshes) {
            if(!mesh.isOutside(pos)) {
                --i;
                pos.x = -1;
                break;
            }
        }

        if(pos.x != -1 && sim->grid.getDomain(pos) == config.rank) {
            sim->insert(pos, vel);
        }
    }

    accumulator = fmod(accumulator, 1);
}
