#ifndef _MODES_HPP
#define _MODES_HPP

#include <SFML/Graphics.hpp>

namespace State {
    enum State {
        RUNNING,
        MANUAL,
        LAST,
        _COUNT
    };
    extern State current;
}

namespace ColorMode {
    enum ColorMode {
        PLAIN,
        PROCESS,
        VELOCITY,
        PRETTY,
        _COUNT
    };
    extern ColorMode current;
}

namespace GuiMode {
    enum GuiMode {
        GRID,
        GUI,
        GUIGRID,
        NONE,
        _COUNT
    };
    extern GuiMode current;
}

template <typename M>
void toggleMode(M& m) {
    m = (M) ((int)m + 1);
    if(m == M::_COUNT) {
        m = (M)0;
    }
}

extern char* outdir;
extern sf::Texture blur;

#endif
